Index: examples/example_scripts/c/abac_prover.c
===================================================================
--- examples/example_scripts/c/abac_prover.c	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/example_scripts/c/abac_prover.c	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -37,4 +37,6 @@
     printf("with %s\n", with);
 
+int k=1; /* use to do repetitions */
+while(k) {
     credentials = abac_context_query(ctx,
                             query, with,
@@ -53,4 +55,6 @@
     if(credentials)
         abac_context_credentials_free(credentials);
+    k=k-1;
+}
 
     abac_context_free(ctx);
Index: examples/passphrase_tests/creddy_prover/acme_rockets_rt0/query.save
===================================================================
--- examples/passphrase_tests/creddy_prover/acme_rockets_rt0/query.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/passphrase_tests/creddy_prover/acme_rockets_rt0/query.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,6 +1,4 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
   
 ===good============ Acme.preferred_customer <- Coyote
-% Restoring file /usr/local/lib/Yap/startup.yss
 YAP query succeed
 prover success!!
@@ -9,5 +7,4 @@
   
 ===good=============== Acme.buy_rockets <- Coyote
-% Restoring file /usr/local/lib/Yap/startup.yss
 YAP query succeed
 prover success!!
@@ -17,9 +14,7 @@
   
 ===bad=============== Acme.buy_rockets <- Acme.preferred_customer
-% Restoring file /usr/local/lib/Yap/startup.yss
 fail, a.o <- b.o and a.r <- a.r query is not implemented yet !!!
   
 ===bad=============== Coyote.friend <- Acme
-% Restoring file /usr/local/lib/Yap/startup.yss
 YAP query failed
 prover failed!!
Index: examples/passphrase_tests/python/acme_rockets_rt0/rocket.save
===================================================================
--- examples/passphrase_tests/python/acme_rockets_rt0/rocket.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/passphrase_tests/python/acme_rockets_rt0/rocket.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/passphrase_tests/python/acme_rockets_rt0_hand/rocket.save
===================================================================
--- examples/passphrase_tests/python/acme_rockets_rt0_hand/rocket.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/passphrase_tests/python/acme_rockets_rt0_hand/rocket.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/access_rt2/access.save
===================================================================
--- examples/python_tests/access_rt2/access.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/access_rt2/access.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/acme_friend_rt1/friend.save
===================================================================
--- examples/python_tests/acme_friend_rt1/friend.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/acme_friend_rt1/friend.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/acme_rockets_intersection_rt0/intersect.save
===================================================================
--- examples/python_tests/acme_rockets_intersection_rt0/intersect.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/acme_rockets_intersection_rt0/intersect.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/acme_rockets_rt0/rocket.save
===================================================================
--- examples/python_tests/acme_rockets_rt0/rocket.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/acme_rockets_rt0/rocket.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/alice_rt1/alice.save
===================================================================
--- examples/python_tests/alice_rt1/alice.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/alice_rt1/alice.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/alumni2_rt1/alumni2.save
===================================================================
--- examples/python_tests/alumni2_rt1/alumni2.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/alumni2_rt1/alumni2.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/alumni3_rt1/alumni3.save
===================================================================
--- examples/python_tests/alumni3_rt1/alumni3.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/alumni3_rt1/alumni3.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/alumni_rt1/alumni.save
===================================================================
--- examples/python_tests/alumni_rt1/alumni.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/alumni_rt1/alumni.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/balltime_rt2/ball.save
===================================================================
--- examples/python_tests/balltime_rt2/ball.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/balltime_rt2/ball.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/basic_id/id.save
===================================================================
--- examples/python_tests/basic_id/id.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/basic_id/id.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 python: Couldn't load ID/KEY IDKEY cert Tom_IDKEY.pem
 ABAC version 0.2.2
Index: examples/python_tests/evaluator_rt1/evaluator.save
===================================================================
--- examples/python_tests/evaluator_rt1/evaluator.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/evaluator_rt1/evaluator.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/experiment_create_rt0/experiment.save
===================================================================
--- examples/python_tests/experiment_create_rt0/experiment.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/experiment_create_rt0/experiment.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/file_read_rt2/file.save
===================================================================
--- examples/python_tests/file_read_rt2/file.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/file_read_rt2/file.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/fruits_rt2/fruit.save
===================================================================
--- examples/python_tests/fruits_rt2/fruit.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/fruits_rt2/fruit.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/leader_rt1/leader.save
===================================================================
--- examples/python_tests/leader_rt1/leader.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/leader_rt1/leader.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/python_tests/payraise_rt1/pay.save
===================================================================
--- examples/python_tests/payraise_rt1/pay.save	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/python_tests/payraise_rt1/pay.save	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -1,3 +1,2 @@
-% Restoring file /usr/local/lib/Yap/startup.yss
 
 ...final principal set...
Index: examples/scaling_tests/Makefile
===================================================================
--- examples/scaling_tests/Makefile	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/scaling_tests/Makefile	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -5,4 +5,5 @@
 
 .PHONY : runcheck clean plot check
+runcheck: $(DIRECTORY)
 
 clean:
Index: examples/scaling_tests/daisychain/likes_python/base/QUERY.py
===================================================================
--- examples/scaling_tests/daisychain/likes_python/base/QUERY.py	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/scaling_tests/daisychain/likes_python/base/QUERY.py	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -132,15 +132,15 @@
 e_time=goodQuery()
 elapsed_micro=get_micro(e_time)
-sys.stderr.write("%d %d GOOD_1(micro)\n" % (cred_count,elapsed_micro))
+sys.stderr.write("%d %d GOOD_f(micro)\n" % (cred_count,elapsed_micro))
 
 elapsed_good=timedelta()
-k=10
+k=100
 while(k):
     e_time=goodQuery()
     elapsed_good=elapsed_good+e_time
     k=k-1
-    if(k==9):
+    if(k==99):
        elapsed_micro=get_micro(e_time)
-       sys.stderr.write("%d %d GOOD_2(micro)\n" % (cred_count,elapsed_micro))
+       sys.stderr.write("%d %d GOOD_s(micro)\n" % (cred_count,elapsed_micro))
 
     if(debug):
@@ -148,5 +148,5 @@
         sys.stderr.write("%d %d GOOD_%d(micro)\n" % (cred_count,elapsed_micro,k))
 elapsed_micro=get_micro(elapsed_good)
-sys.stderr.write("%d %d GOOD_t(micro)\n" % (cred_count,elapsed_micro/10))
+sys.stderr.write("%d %d GOOD_t(micro)\n" % (cred_count,elapsed_micro/100))
 
 
@@ -155,15 +155,15 @@
 e_time=badQuery()
 elapsed_micro=get_micro(e_time)
-sys.stderr.write("%d %d BAD_1(micro)\n" % (cred_count,elapsed_micro))
+sys.stderr.write("%d %d BAD_f(micro)\n" % (cred_count,elapsed_micro))
 
 elapsed_bad=timedelta()
-k=10
+k=100
 while(k):
     e_time=badQuery()
     elapsed_bad=elapsed_bad+e_time
     k=k-1
-    if(k==9):
+    if(k==99):
         elapsed_micro=get_micro(e_time)
-        sys.stderr.write("%d %d BAD_2(micro)\n" % (cred_count,elapsed_micro))
+        sys.stderr.write("%d %d BAD_s(micro)\n" % (cred_count,elapsed_micro))
 
     if(debug):
@@ -172,3 +172,3 @@
 
 elapsed_micro=get_micro(elapsed_bad)
-sys.stderr.write("%d %d BAD_t(micro)\n" % (cred_count,elapsed_micro/10))
+sys.stderr.write("%d %d BAD_t(micro)\n" % (cred_count,elapsed_micro/100))
Index: examples/scaling_tests/haystack/fruit_python/base/QUERY.py
===================================================================
--- examples/scaling_tests/haystack/fruit_python/base/QUERY.py	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/scaling_tests/haystack/fruit_python/base/QUERY.py	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -110,5 +110,5 @@
 e_time=maryQuery(1)
 elapsed_micro=get_micro(e_time)
-sys.stderr.write("%d %d GOOD_1(micro)\n" % (cred_count,elapsed_micro))
+sys.stderr.write("%d %d GOOD_f(micro)\n" % (cred_count,elapsed_micro))
 
 elapsed_good=timedelta()
@@ -159,5 +159,5 @@
 e_time=bobQuery(1)
 elapsed_micro=get_micro(e_time)
-sys.stderr.write("%d %d BAD_1(micro)\n" % (cred_count,elapsed_micro))
+sys.stderr.write("%d %d BAD_f(micro)\n" % (cred_count,elapsed_micro))
 
 elapsed_bad=timedelta()
Index: examples/scaling_tests/haystack/fruit_python/base/RESULT
===================================================================
--- examples/scaling_tests/haystack/fruit_python/base/RESULT	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/scaling_tests/haystack/fruit_python/base/RESULT	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -24,4 +24,84 @@
 YAP query succeed
 YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
+YAP query succeed
 
 ===good============ mary.what2eat <- kiwi
@@ -52,4 +132,84 @@
 YAP query failed
 YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
+YAP query failed
 
 ===good============ ralphs.fruitprice(1.50) <- apple
Index: examples/scaling_tests/plotting/split_it
===================================================================
--- examples/scaling_tests/plotting/split_it	(revision 94a4dd2085ed16b095b7627da3921af657f4d235)
+++ examples/scaling_tests/plotting/split_it	(revision bf68132099528b5ef3b99d76a9ef95b77b4095a2)
@@ -14,7 +14,7 @@
 
   grep "GOOD_t" $filename | sort -n  > ${type}_mgood.dat
-  grep "GOOD_1" $filename | sort -n > ${type}_good1.dat
+  grep "GOOD_f" $filename | sort -n > ${type}_good1.dat
   grep "BAD_t" $filename | sort -n > ${type}_mbad.dat
-  grep "BAD_1" $filename | sort -n > ${type}_bad1.dat
+  grep "BAD_f" $filename | sort -n > ${type}_bad1.dat
   grep "LOAD" $filename | sort -n > ${type}_load.dat
 
